<template>
	<xn-form-container
		:title="'编辑提货重量'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-descriptions :column="4" size="middle" bordered class="mb-2" :label-style="labelStyle" :contentStyle="contentStyle">
			<a-descriptions-item label="货品编码" :span="4">{{ formData.goodsCode }}</a-descriptions-item>
			<a-descriptions-item label="货品信息" :span="4">{{ formData.goodsName }} ( {{ formData.goodsModel }} )</a-descriptions-item>
			<a-descriptions-item label="提货时间段" :span="4">{{ formData.confStartTime }} ~ {{ formData.confEndTime }}</a-descriptions-item>
			<a-descriptions-item label="原最大提货重量" :span="4">{{ confWeight }} KG</a-descriptions-item>
			<a-descriptions-item label="已提货重量" :span="4">{{ formData.usedWeight }} KG</a-descriptions-item>
			<a-descriptions-item label="剩余提货重量" :span="4">{{ formData.lastWeight }} KG</a-descriptions-item>
		</a-descriptions>

		<a-form ref="formRef" :model="formData" :rules="formRules" :wrapper-col="wrapperCol" :label-col="labelCol">
			<a-form-item label="最大提货重量(KG)：" name="confWeight">
				<a-input-number v-model:value="formData.confWeight" :min="formData.usedWeight" placeholder="请输入最大提货重量" allow-clear />
			</a-form-item>
		</a-form>

		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="goodsConfForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import goodsConfApi from '@/api/biz/goodsConfApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)
	const confWeight = ref("")

	//设置表单样式
	const labelCol = ref({ span: 5})
	const wrapperCol = ref({ span: 16})

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
			confWeight.value = formData.value.confWeight
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
		confWeight: [required("请输入最大提货重量")]
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				goodsConfApi
					.goodsConfSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
